/* A Bison parser, made from .././ConfigParser.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse ConfigParser_parse
#define yylex ConfigParser_lex
#define yyerror ConfigParser_error
#define yylval ConfigParser_lval
#define yychar ConfigParser_char
#define yydebug ConfigParser_debug
#define yynerrs ConfigParser_nerrs
# define	PRTOKEN_VISUAL	257
# define	PRTOKEN_SET_SIMPLE	258
# define	PRTOKEN_VISUAL_ID	259
# define	PRTOKEN_BUFFER_SIZE	260
# define	PRTOKEN_LEVEL	261
# define	PRTOKEN_RGBA	262
# define	PRTOKEN_DOUBLEBUFFER	263
# define	PRTOKEN_STEREO	264
# define	PRTOKEN_AUX_BUFFERS	265
# define	PRTOKEN_RED_SIZE	266
# define	PRTOKEN_GREEN_SIZE	267
# define	PRTOKEN_BLUE_SIZE	268
# define	PRTOKEN_ALPHA_SIZE	269
# define	PRTOKEN_DEPTH_SIZE	270
# define	PRTOKEN_STENCIL_SIZE	271
# define	PRTOKEN_ACCUM_RED_SIZE	272
# define	PRTOKEN_ACCUM_GREEN_SIZE	273
# define	PRTOKEN_ACCUM_BLUE_SIZE	274
# define	PRTOKEN_ACCUM_ALPHA_SIZE	275
# define	PRTOKEN_RENDER_SURFACE	276
# define	PRTOKEN_WINDOW_RECT	277
# define	PRTOKEN_INPUT_RECT	278
# define	PRTOKEN_HOSTNAME	279
# define	PRTOKEN_DISPLAY	280
# define	PRTOKEN_SCREEN	281
# define	PRTOKEN_BORDER	282
# define	PRTOKEN_CAMERA_GROUP	283
# define	PRTOKEN_CAMERA	284
# define	PRTOKEN_PROJECTION_RECT	285
# define	PRTOKEN_LENS	286
# define	PRTOKEN_FRUSTUM	287
# define	PRTOKEN_PERSPECTIVE	288
# define	PRTOKEN_ORTHO	289
# define	PRTOKEN_OFFSET	290
# define	PRTOKEN_ROTATE	291
# define	PRTOKEN_TRANSLATE	292
# define	PRTOKEN_SCALE	293
# define	PRTOKEN_SHEAR	294
# define	PRTOKEN_INPUT_AREA	295
# define	PRTOKEN_ERROR	296
# define	PRTOKEN_INTEGER	297
# define	PRTOKEN_HEX_INTEGER	298
# define	PRTOKEN_FLOAT	299
# define	PRTOKEN_TRUE	300
# define	PRTOKEN_FALSE	301
# define	PRTOKEN_QUOTED_STRING	302
# define	PRTOKEN_STEREO_SYSTEM_COMMANDS	303



#ifndef WIN32
#include <unistd.h>
#include <sys/wait.h>
#include <stdlib.h>
#include <fcntl.h>
#endif

#ifdef WIN32
#define PRODUCER_AVOID_CPP 1
#endif

#include <stdio.h>
#include <fstream>
#include <string>

#include "FlexLexer.h"

#include <Producer/CameraConfig>


using namespace std;
using namespace Producer;

static void ConfigParser_error( const char * );
static CameraConfig *cfg = 0L;
static std::string fileName = "(stdin)";

static yyFlexLexer *flexer = 0L;

static int yylex()
{
    if( flexer == 0L )
        fprintf( stderr, "Internal error!\n" );
    return flexer->yylex();
}


#ifndef YYSTYPE
typedef union {
    char * string;
    int    integer;
    float  real;
    bool boolean;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		214
#define	YYFLAG		-32768
#define	YYNTBASE	54

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 303 ? yytranslate[x] : 92)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    53,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    50,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    51,     2,    52,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     4,     7,     9,    11,    13,    15,    17,
      19,    25,    30,    32,    33,    35,    38,    39,    46,    48,
      51,    52,    56,    58,    65,    67,    69,    70,    76,    78,
      81,    86,    93,    99,   105,   110,   112,   115,   116,   125,
     136,   143,   152,   161,   172,   177,   178,   185,   187,   190,
     191,   195,   197,   204,   211,   215,   219,   223,   227,   228,
     235,   236,   242,   244,   248,   250,   253,   256,   259,   261,
     263,   265,   268,   271,   274,   277,   280,   283,   286,   289,
     292,   295,   298,   300,   303,   304,   310,   312,   315,   319,
     321,   323,   325,   327,   329,   331,   333,   335
};
static const short yyrhs[] =
{
      55,     0,    56,     0,    55,    56,     0,    76,     0,    72,
       0,    61,     0,    81,     0,    58,     0,    57,     0,    49,
      87,    89,    89,    50,     0,    29,    51,    59,    52,     0,
      60,     0,     0,    61,     0,    60,    61,     0,     0,    30,
      88,    62,    51,    63,    52,     0,    64,     0,    63,    64,
       0,     0,    22,    88,    50,     0,    72,     0,    31,    85,
      85,    85,    85,    50,     0,    69,     0,    65,     0,     0,
      36,    51,    66,    67,    52,     0,    68,     0,    67,    68,
       0,    40,    85,    85,    50,     0,    37,    85,    85,    85,
      85,    50,     0,    38,    85,    85,    85,    50,     0,    39,
      85,    85,    85,    50,     0,    32,    51,    70,    52,     0,
      71,     0,    70,    71,     0,     0,    35,    85,    85,    85,
      85,    85,    85,    50,     0,    35,    85,    85,    85,    85,
      85,    85,    85,    85,    50,     0,    34,    85,    85,    85,
      85,    50,     0,    34,    85,    85,    85,    85,    85,    85,
      50,     0,    33,    85,    85,    85,    85,    85,    85,    50,
       0,    33,    85,    85,    85,    85,    85,    85,    85,    85,
      50,     0,    40,    85,    85,    50,     0,     0,    22,    88,
      73,    51,    74,    52,     0,    75,     0,    74,    75,     0,
       0,     3,    88,    50,     0,    76,     0,    23,    87,    87,
      87,    87,    50,     0,    24,    86,    86,    86,    86,    50,
       0,    25,    88,    50,     0,    26,    87,    50,     0,    27,
      87,    50,     0,    28,    91,    50,     0,     0,     3,    88,
      77,    51,    79,    52,     0,     0,     3,    78,    51,    79,
      52,     0,    80,     0,    79,    53,    80,     0,     4,     0,
       5,    90,     0,     6,    87,     0,     7,    87,     0,     8,
       0,     9,     0,    10,     0,    11,    87,     0,    12,    87,
       0,    13,    87,     0,    14,    87,     0,    15,    87,     0,
      16,    87,     0,    17,    87,     0,    18,    87,     0,    19,
      87,     0,    20,    87,     0,    21,    87,     0,    87,     0,
      87,    87,     0,     0,    41,    82,    51,    83,    52,     0,
      84,     0,    83,    84,     0,    22,    88,    50,     0,    45,
       0,    43,     0,    45,     0,    43,     0,    48,     0,    48,
       0,    44,     0,    46,     0,    47,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   111,   114,   114,   117,   117,   117,   117,   117,   117,
     120,   126,   129,   132,   132,   132,   135,   135,   144,   144,
     147,   149,   153,   157,   161,   162,   165,   165,   175,   175,
     178,   183,   187,   191,   197,   200,   200,   203,   205,   209,
     213,   217,   221,   225,   229,   235,   235,   245,   245,   248,
     250,   254,   258,   262,   266,   270,   274,   278,   286,   286,
     295,   295,   306,   306,   308,   313,   318,   322,   327,   331,
     335,   339,   343,   348,   353,   357,   361,   365,   369,   373,
     377,   381,   385,   389,   395,   395,   401,   401,   404,   411,
     415,   422,   428,   434,   440,   447,   455,   455
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "PRTOKEN_VISUAL", "PRTOKEN_SET_SIMPLE", 
  "PRTOKEN_VISUAL_ID", "PRTOKEN_BUFFER_SIZE", "PRTOKEN_LEVEL", 
  "PRTOKEN_RGBA", "PRTOKEN_DOUBLEBUFFER", "PRTOKEN_STEREO", 
  "PRTOKEN_AUX_BUFFERS", "PRTOKEN_RED_SIZE", "PRTOKEN_GREEN_SIZE", 
  "PRTOKEN_BLUE_SIZE", "PRTOKEN_ALPHA_SIZE", "PRTOKEN_DEPTH_SIZE", 
  "PRTOKEN_STENCIL_SIZE", "PRTOKEN_ACCUM_RED_SIZE", 
  "PRTOKEN_ACCUM_GREEN_SIZE", "PRTOKEN_ACCUM_BLUE_SIZE", 
  "PRTOKEN_ACCUM_ALPHA_SIZE", "PRTOKEN_RENDER_SURFACE", 
  "PRTOKEN_WINDOW_RECT", "PRTOKEN_INPUT_RECT", "PRTOKEN_HOSTNAME", 
  "PRTOKEN_DISPLAY", "PRTOKEN_SCREEN", "PRTOKEN_BORDER", 
  "PRTOKEN_CAMERA_GROUP", "PRTOKEN_CAMERA", "PRTOKEN_PROJECTION_RECT", 
  "PRTOKEN_LENS", "PRTOKEN_FRUSTUM", "PRTOKEN_PERSPECTIVE", 
  "PRTOKEN_ORTHO", "PRTOKEN_OFFSET", "PRTOKEN_ROTATE", 
  "PRTOKEN_TRANSLATE", "PRTOKEN_SCALE", "PRTOKEN_SHEAR", 
  "PRTOKEN_INPUT_AREA", "PRTOKEN_ERROR", "PRTOKEN_INTEGER", 
  "PRTOKEN_HEX_INTEGER", "PRTOKEN_FLOAT", "PRTOKEN_TRUE", "PRTOKEN_FALSE", 
  "PRTOKEN_QUOTED_STRING", "PRTOKEN_STEREO_SYSTEM_COMMANDS", "';'", "'{'", 
  "'}'", "','", "config", "entries", "entry", "stereo_param", 
  "camera_group", "camera_group_attributes", "cameras", "camera", "@1", 
  "camera_attributes", "camera_attribute", "camera_offset", "@2", 
  "camera_offset_attributes", "camera_offset_attribute", "lens", 
  "lens_attributes", "lens_attribute", "render_surface", "@3", 
  "render_surface_attributes", "render_surface_attribute", "visual", "@4", 
  "@5", "visual_attributes", "visual_attribute", "input_area", "@6", 
  "input_area_entries", "input_area_entry", "real", "floatparam", 
  "intparam", "name", "string", "hex_integer", "bool", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    54,    55,    55,    56,    56,    56,    56,    56,    56,
      57,    58,    59,    60,    60,    60,    62,    61,    63,    63,
      64,    64,    64,    64,    64,    64,    66,    65,    67,    67,
      68,    68,    68,    68,    69,    70,    70,    71,    71,    71,
      71,    71,    71,    71,    71,    73,    72,    74,    74,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    77,    76,
      78,    76,    79,    79,    80,    80,    80,    80,    80,    80,
      80,    80,    80,    80,    80,    80,    80,    80,    80,    80,
      80,    80,    80,    80,    82,    81,    83,    83,    84,    85,
      85,    86,    87,    88,    89,    90,    91,    91
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       5,     4,     1,     0,     1,     2,     0,     6,     1,     2,
       0,     3,     1,     6,     1,     1,     0,     5,     1,     2,
       4,     6,     5,     5,     4,     1,     2,     0,     8,    10,
       6,     8,     8,    10,     4,     0,     6,     1,     2,     0,
       3,     1,     6,     6,     3,     3,     3,     3,     0,     6,
       0,     5,     1,     3,     1,     2,     2,     2,     1,     1,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     1,     2,     0,     5,     1,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,    60,     0,     0,     0,    84,     0,     1,     2,     9,
       8,     6,     5,     4,     7,    93,     0,    58,    45,    13,
      16,     0,    92,     0,     3,     0,     0,     0,     0,    12,
      14,     0,     0,    94,     0,    64,     0,     0,     0,    68,
      69,    70,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    62,    82,     0,    49,    11,    15,
      20,     0,     0,    86,     0,    95,    65,    66,    67,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      61,     0,    83,     0,    60,     0,     0,     0,     0,     0,
       0,     0,    47,    51,     0,     0,     0,     0,     0,    18,
      25,    24,    22,     0,    85,    87,    10,    63,    59,    58,
       0,    91,     0,     0,     0,     0,    96,    97,     0,    46,
      48,    45,    90,    89,     0,    37,    26,    17,    19,    88,
      50,     0,     0,    54,    55,    56,    57,    21,     0,     0,
       0,     0,     0,     0,    35,     0,     0,     0,     0,     0,
       0,     0,     0,    34,    36,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    27,    29,    52,    53,    23,     0,     0,     0,
      44,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    30,     0,    40,     0,     0,     0,    32,    33,     0,
       0,     0,    31,    42,     0,    41,    38,     0,     0,     0,
      43,    39,     0,     0,     0
};

static const short yydefgoto[] =
{
     212,     7,     8,     9,    10,    28,    29,    11,    31,    98,
      99,   100,   145,   159,   160,   101,   143,   144,    12,    27,
      91,    92,    13,    26,    16,    53,    54,    14,    21,    62,
      63,   124,   112,    55,    17,    34,    66,   118
};

static const short yypact[] =
{
      26,   -45,   -45,   -44,   -45,-32768,   -23,    26,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,     7,-32768,-32768,     4,
  -32768,    15,-32768,   -20,-32768,   154,    27,    35,     8,     4,
  -32768,    42,    54,-32768,   -20,-32768,    51,   -23,   -23,-32768,
  -32768,-32768,   -23,   -23,   -23,   -23,   -23,   -23,   -23,   -23,
     -23,   -23,   -23,    17,-32768,   -23,   154,   153,-32768,-32768,
      49,   -45,     5,-32768,    53,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,   154,-32768,    20,   -45,   -23,    64,   -45,   -23,   -23,
      50,    -2,-32768,-32768,   -45,   -35,    62,    71,   -17,-32768,
  -32768,-32768,-32768,    73,-32768,-32768,-32768,-32768,-32768,    74,
     -23,-32768,    64,    76,    80,    84,-32768,-32768,    93,-32768,
  -32768,    97,-32768,-32768,   -35,    77,-32768,-32768,-32768,-32768,
  -32768,   -23,    64,-32768,-32768,-32768,-32768,-32768,   -35,   -35,
     -35,   -35,   -35,   -22,-32768,   145,   -23,    64,   -35,   -35,
     -35,   -35,   -35,-32768,-32768,   -35,   -35,   -35,   -35,    25,
  -32768,   102,   103,   136,   -35,   -35,   -35,   137,   -35,   -35,
     -35,   -35,-32768,-32768,-32768,-32768,-32768,   -35,   -35,   -35,
  -32768,   -35,   -35,   -35,   138,   -35,     9,   -35,   -35,   139,
     140,-32768,   -35,-32768,   -35,   -35,   141,-32768,-32768,    96,
     142,   105,-32768,-32768,   -35,-32768,-32768,   -35,   143,   144,
  -32768,-32768,   195,   196,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,   191,-32768,-32768,-32768,-32768,   -13,-32768,-32768,
     101,-32768,-32768,-32768,    41,-32768,-32768,    58,   -51,-32768,
  -32768,   111,   -40,-32768,-32768,   147,   123,-32768,-32768,-32768,
     146,   -50,   -79,    -6,     0,   171,-32768,-32768
};


#define	YYLAST		208


static const short yytable[] =
{
      23,    84,    18,    15,    20,    94,    30,    19,   122,   102,
     123,   139,   140,   141,    95,    96,    59,    93,   142,    97,
      22,    85,    86,    87,    88,    89,    90,    61,    33,     1,
     153,    67,    68,   132,     4,   127,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,   102,     2,    82,
     119,    93,   122,   147,   123,     3,     4,   104,    25,   193,
      58,   103,   155,   156,   157,   158,    32,     5,   162,    80,
      81,    94,   108,    81,   138,     6,    61,   172,    56,   110,
      95,    96,   114,   115,   109,    97,    57,   113,   148,   149,
     150,   151,   152,    60,   121,    65,   116,   117,   163,   164,
     165,   166,   167,   106,   131,   168,   169,   170,   171,   111,
     139,   140,   141,   125,   177,   178,   179,   142,   181,   182,
     183,   184,   126,   129,   130,   146,   133,   185,   186,   187,
     134,   188,   189,   190,   135,   192,   194,   195,   196,   122,
     161,   123,   199,   136,   200,   201,   203,   137,   122,   204,
     123,   207,   174,   175,   208,   206,    84,   209,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    85,    86,    87,    88,
      89,    90,   155,   156,   157,   158,   176,   180,   191,   197,
     198,   202,   205,   210,   211,   213,   214,    22,    24,   128,
     173,   154,   120,    83,   107,    64,     0,     0,   105
};

static const short yycheck[] =
{
       6,     3,     2,    48,     4,    22,    19,    51,    43,    60,
      45,    33,    34,    35,    31,    32,    29,    57,    40,    36,
      43,    23,    24,    25,    26,    27,    28,    22,    48,     3,
      52,    37,    38,   112,    30,    52,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    98,    22,    55,
      52,    91,    43,   132,    45,    29,    30,    52,    51,    50,
      52,    61,    37,    38,    39,    40,    51,    41,   147,    52,
      53,    22,    52,    53,   124,    49,    22,    52,    51,    85,
      31,    32,    88,    89,    84,    36,    51,    87,   138,   139,
     140,   141,   142,    51,    94,    44,    46,    47,   148,   149,
     150,   151,   152,    50,   110,   155,   156,   157,   158,    45,
      33,    34,    35,    51,   164,   165,   166,    40,   168,   169,
     170,   171,    51,    50,    50,   131,    50,   177,   178,   179,
      50,   181,   182,   183,    50,   185,   186,   187,   188,    43,
     146,    45,   192,    50,   194,   195,    50,    50,    43,   199,
      45,   201,    50,    50,   204,    50,     3,   207,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    23,    24,    25,    26,
      27,    28,    37,    38,    39,    40,    50,    50,    50,    50,
      50,    50,    50,    50,    50,     0,     0,    43,     7,    98,
     159,   143,    91,    56,    81,    34,    -1,    -1,    62
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 10:
{
           cfg->addStereoSystemCommand( yyvsp[-3].integer, yyvsp[-2].string, yyvsp[-1].string );
        ;
    break;}
case 16:
{
	    cfg->beginCamera( yyvsp[0].string );
	 ;
    break;}
case 17:
{
	    cfg->endCamera();
	 ;
    break;}
case 21:
{
	    cfg->setCameraRenderSurface( yyvsp[-1].string );
	;
    break;}
case 22:
{
	    cfg->setCameraRenderSurface();
	;
    break;}
case 23:
{
	    cfg->setCameraProjectionRectangle( yyvsp[-4].real, yyvsp[-3].real, yyvsp[-2].real, yyvsp[-1].real );
	;
    break;}
case 26:
{
	    cfg->beginCameraOffset();
	;
    break;}
case 27:
{
	    cfg->endCameraOffset();
	;
    break;}
case 30:
{
	    cfg->shearCameraOffset( yyvsp[-2].real, yyvsp[-1].real );
	  ;
    break;}
case 31:
{
	    cfg->rotateCameraOffset( yyvsp[-4].real, yyvsp[-3].real, yyvsp[-2].real, yyvsp[-1].real );
	  ;
    break;}
case 32:
{
	    cfg->translateCameraOffset( yyvsp[-3].real, yyvsp[-2].real, yyvsp[-1].real );
	  ;
    break;}
case 33:
{
	    cfg->scaleCameraOffset( yyvsp[-3].real, yyvsp[-2].real, yyvsp[-1].real );
	  ;
    break;}
case 38:
{
	      cfg->setCameraOrtho( yyvsp[-6].real, yyvsp[-5].real, yyvsp[-4].real, yyvsp[-3].real, yyvsp[-2].real, yyvsp[-1].real );
	  ;
    break;}
case 39:
{
	      cfg->setCameraOrtho( yyvsp[-8].real, yyvsp[-7].real, yyvsp[-6].real, yyvsp[-5].real, yyvsp[-4].real, yyvsp[-3].real, yyvsp[-2].real, yyvsp[-1].real );
	  ;
    break;}
case 40:
{
	      cfg->setCameraPerspective( yyvsp[-4].real, yyvsp[-3].real, yyvsp[-2].real, yyvsp[-1].real );
	  ;
    break;}
case 41:
{
	      cfg->setCameraPerspective( yyvsp[-6].real, yyvsp[-5].real, yyvsp[-4].real, yyvsp[-3].real, yyvsp[-2].real, yyvsp[-1].real );
	  ;
    break;}
case 42:
{
	      cfg->setCameraFrustum( yyvsp[-6].real, yyvsp[-5].real, yyvsp[-4].real, yyvsp[-3].real, yyvsp[-2].real, yyvsp[-1].real );
	  ;
    break;}
case 43:
{
	      cfg->setCameraFrustum( yyvsp[-8].real, yyvsp[-7].real, yyvsp[-6].real, yyvsp[-5].real, yyvsp[-4].real, yyvsp[-3].real, yyvsp[-2].real, yyvsp[-1].real );
	  ;
    break;}
case 44:
{
	      cfg->setCameraLensShear( yyvsp[-2].real, yyvsp[-1].real );
	  ;
    break;}
case 45:
{
	     cfg->beginRenderSurface( yyvsp[0].string );
	 ;
    break;}
case 46:
{
	     cfg->endRenderSurface();
	 ;
    break;}
case 50:
{
	    cfg->setRenderSurfaceVisualChooser( yyvsp[-1].string );
	;
    break;}
case 51:
{
	    cfg->setRenderSurfaceVisualChooser();
	;
    break;}
case 52:
{
	    cfg->setRenderSurfaceWindowRectangle( yyvsp[-4].integer, yyvsp[-3].integer, yyvsp[-2].integer, yyvsp[-1].integer );
	;
    break;}
case 53:
{
        cfg->setRenderSurfaceInputRectangle( yyvsp[-4].real, yyvsp[-3].real, yyvsp[-2].real, yyvsp[-1].real );
    ;
    break;}
case 54:
{
	    cfg->setRenderSurfaceHostName( std::string(yyvsp[-1].string) );
	;
    break;}
case 55:
{
	    cfg->setRenderSurfaceDisplayNum( yyvsp[-1].integer );
	;
    break;}
case 56:
{
	    cfg->setRenderSurfaceScreen( yyvsp[-1].integer );
	;
    break;}
case 57:
{    
	    cfg->setRenderSurfaceBorder( yyvsp[-1].boolean );
	;
    break;}
case 58:
{
	     cfg->beginVisual( yyvsp[0].string );
	 ;
    break;}
case 59:
{
	     cfg->endVisual();
	 ;
    break;}
case 60:
{
	     cfg->beginVisual();
	 ;
    break;}
case 61:
{
	     cfg->endVisual();
	 ;
    break;}
case 64:
{
	      cfg->setVisualSimpleConfiguration();
	  ;
    break;}
case 65:
{
	      cfg->setVisualByID( yyvsp[0].integer );
	  ;
    break;}
case 66:
{
	      cfg->addVisualAttribute( VisualChooser::BufferSize, yyvsp[0].integer );
	  ;
    break;}
case 67:
{
	      cfg->addVisualAttribute( VisualChooser::Level, yyvsp[0].integer );
	  ;
    break;}
case 68:
{
	      cfg->addVisualAttribute( VisualChooser::RGBA );
	  ;
    break;}
case 69:
{
	      cfg->addVisualAttribute( VisualChooser::DoubleBuffer );
	  ;
    break;}
case 70:
{
	      cfg->addVisualAttribute( VisualChooser::Stereo );
	  ;
    break;}
case 71:
{
	      cfg->addVisualAttribute( VisualChooser::AuxBuffers, yyvsp[0].integer );
	  ;
    break;}
case 72:
{
	      cfg->addVisualAttribute( VisualChooser::RedSize, yyvsp[0].integer );
	  ;
    break;}
case 73:
{
	      cfg->addVisualAttribute( VisualChooser::GreenSize, yyvsp[0].integer );
	  ;
    break;}
case 74:
{
	      cfg->addVisualAttribute( VisualChooser::BlueSize, yyvsp[0].integer );
	  ;
    break;}
case 75:
{
	      cfg->addVisualAttribute( VisualChooser::AlphaSize, yyvsp[0].integer );
	  ;
    break;}
case 76:
{
	      cfg->addVisualAttribute( VisualChooser::DepthSize, yyvsp[0].integer );
	  ;
    break;}
case 77:
{
	      cfg->addVisualAttribute( VisualChooser::StencilSize, yyvsp[0].integer );
	  ;
    break;}
case 78:
{
	      cfg->addVisualAttribute( VisualChooser::AccumRedSize, yyvsp[0].integer );
	  ;
    break;}
case 79:
{
	      cfg->addVisualAttribute( VisualChooser::AccumGreenSize, yyvsp[0].integer );
	  ;
    break;}
case 80:
{
	      cfg->addVisualAttribute( VisualChooser::AccumBlueSize, yyvsp[0].integer );
	  ;
    break;}
case 81:
{
	      cfg->addVisualAttribute( VisualChooser::AccumAlphaSize, yyvsp[0].integer );
	  ;
    break;}
case 82:
{
	      cfg->addVisualExtendedAttribute( yyvsp[0].integer );
	  ;
    break;}
case 83:
{
	      cfg->addVisualExtendedAttribute( yyvsp[-1].integer, yyvsp[0].integer );
	  ;
    break;}
case 84:
{ cfg->beginInputArea(); ;
    break;}
case 85:
{ cfg->endInputArea(); ;
    break;}
case 88:
{
			cfg->addInputAreaEntry( yyvsp[-1].string );
		;
    break;}
case 89:
{
	    yyval.real = atof(flexer->YYText());
	;
    break;}
case 90:
{
	    yyval.real = atof(flexer->YYText());
	;
    break;}
case 91:
{
	    yyval.real = atof(flexer->YYText());
	;
    break;}
case 92:
{
	    yyval.integer = atoi( flexer->YYText() );
	;
    break;}
case 93:
{
	    yyval.string = strdup( flexer->YYText() );
	;
    break;}
case 94:
{
	    yyval.string = strdup( flexer->YYText() );
	;
    break;}
case 95:
{
	    int n;
	    sscanf( flexer->YYText(), "0x%x", &n );
	    yyval.integer = n;
	;
    break;}
case 96:
{ yyval.boolean = true;;
    break;}
case 97:
{ yyval.boolean = false; ;
    break;}
}



  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


static void yyerror( const char *errmsg )
{
    fprintf( stderr, 
    	"CameraConfig::parseFile(\"%s\") : %s - Line %d at or before \"%s\"\n",
		fileName.c_str(),
		errmsg, 
        flexer->lineno(),
        flexer->YYText() );
}

bool CameraConfig::parseFile( const std::string &file )
{
    fileName.clear();

    fileName = findFile(file);

    if( fileName.empty() )
    {
        fprintf( stderr, "CameraConfig::parseFile() - Can't find file \"%s\".\n", file.c_str() );
        return false;
    }

#if defined (PRODUCER_AVOID_CPP)

    std::ifstream ifs(fileName.c_str());
    flexer = new yyFlexLexer(&ifs);
    cfg = this;
    bool retval = true;
    if( ConfigParser_parse() )
        retval = false;
    ifs.close();
    delete flexer;
    return retval;

#else

    int pd[2];
    bool retval = true;
    pipe( pd );

    flexer = new yyFlexLexer;
    if( fork() == 0 )
    {
        // we don't want to read from the pipe in the child, so close it.
        close( pd[0] );
        close( 1 );
        dup( pd[1] );

        char *cpp_path =
#if defined(__APPLE__)
                "/usr/bin/cpp";
#else
                "/lib/cpp";
#endif

        /* This was here to allow reading a config file from stdin.
         * This has never been directly supported, so commenting out.
        if( fileName.empty() )
            execlp( cpp_path, "cpp",  "-P", 0L );
        else
        */
            execlp( cpp_path, "cpp",  "-P", fileName.c_str(), 0L );
                                                                                                                     
        // This should not execute unless an error happens
        perror( "execlp" );
    }
    else
    {
        close( pd[1]);
        close( 0 );
        dup( pd[0] );

        cfg = this;

        int retval = ConfigParser_parse();
                                                                                                                     
        // Wait on child process to finish
        int stat;
        wait( &stat );
                                                                                                                     
        return retval;
    }
#endif
}

