#ifndef BISON______CONFIGPARSER_H
# define BISON______CONFIGPARSER_H

#ifndef YYSTYPE
typedef union {
    char * string;
    int    integer;
    float  real;
    bool boolean;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	PRTOKEN_VISUAL	257
# define	PRTOKEN_SET_SIMPLE	258
# define	PRTOKEN_VISUAL_ID	259
# define	PRTOKEN_BUFFER_SIZE	260
# define	PRTOKEN_LEVEL	261
# define	PRTOKEN_RGBA	262
# define	PRTOKEN_DOUBLEBUFFER	263
# define	PRTOKEN_STEREO	264
# define	PRTOKEN_AUX_BUFFERS	265
# define	PRTOKEN_RED_SIZE	266
# define	PRTOKEN_GREEN_SIZE	267
# define	PRTOKEN_BLUE_SIZE	268
# define	PRTOKEN_ALPHA_SIZE	269
# define	PRTOKEN_DEPTH_SIZE	270
# define	PRTOKEN_STENCIL_SIZE	271
# define	PRTOKEN_ACCUM_RED_SIZE	272
# define	PRTOKEN_ACCUM_GREEN_SIZE	273
# define	PRTOKEN_ACCUM_BLUE_SIZE	274
# define	PRTOKEN_ACCUM_ALPHA_SIZE	275
# define	PRTOKEN_RENDER_SURFACE	276
# define	PRTOKEN_WINDOW_RECT	277
# define	PRTOKEN_INPUT_RECT	278
# define	PRTOKEN_HOSTNAME	279
# define	PRTOKEN_DISPLAY	280
# define	PRTOKEN_SCREEN	281
# define	PRTOKEN_BORDER	282
# define	PRTOKEN_CAMERA_GROUP	283
# define	PRTOKEN_CAMERA	284
# define	PRTOKEN_PROJECTION_RECT	285
# define	PRTOKEN_LENS	286
# define	PRTOKEN_FRUSTUM	287
# define	PRTOKEN_PERSPECTIVE	288
# define	PRTOKEN_ORTHO	289
# define	PRTOKEN_OFFSET	290
# define	PRTOKEN_ROTATE	291
# define	PRTOKEN_TRANSLATE	292
# define	PRTOKEN_SCALE	293
# define	PRTOKEN_SHEAR	294
# define	PRTOKEN_INPUT_AREA	295
# define	PRTOKEN_ERROR	296
# define	PRTOKEN_INTEGER	297
# define	PRTOKEN_HEX_INTEGER	298
# define	PRTOKEN_FLOAT	299
# define	PRTOKEN_TRUE	300
# define	PRTOKEN_FALSE	301
# define	PRTOKEN_QUOTED_STRING	302
# define	PRTOKEN_STEREO_SYSTEM_COMMANDS	303


extern YYSTYPE ConfigParser_lval;

#endif /* not BISON______CONFIGPARSER_H */
